This service will be undergoing maintenance at 00:00 UTC, 2016-08-01. It is expected to last about 1 hours
Bug 488665 - Review Request: hscolour - Haskell source code highlighter
Review Request: hscolour - Haskell source code highlighter
Status: CLOSED NEXTRELEASE
Product: Fedora
Classification: Fedora
Component: Package Review (Show other bugs)
rawhide
All Linux
medium Severity medium
: ---
: ---
Assigned To: Yaakov Nemoy
Fedora Extras Quality Assurance
:
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2009-03-04 23:13 EST by Jens Petersen
Modified: 2012-06-02 13:30 EDT (History)
4 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2009-03-18 01:42:50 EDT
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
loupgaroublond: fedora‑review+
limburgher: fedora‑cvs+


Attachments (Terms of Use)

  None (edit)
Description Jens Petersen 2009-03-04 23:13:42 EST
Spec URL: http://petersen.fedorapeople.org/hscolour/hscolour.spec
SRPM URL: http://petersen.fedorapeople.org/hscolour/hscolour-1.12-1.fc10.src.rpm
Description: 
Tool for coloring Haskell source code.
Comment 1 Yaakov Nemoy 2009-03-09 00:44:41 EDT
Here begins the review

After eyeballing it, of note, the actual url is:
http://www.cs.york.ac.uk/fp/darcs/hscolour/

This begs the question, do we want to put the onus on the packager to go to the hackage page and see if there is an alternate link given? Since that link is given in the cabal file anyways, should cabal2spec pull it out automatically? Or rather, do we want to have some sort of OCD everything must link to hackage if it's available there so we can be sure it's a hackage package?

IMO the upstream maintains a nice website.

#  MUST: rpmlint must be run on every package. The output should be posted in the review.[1]

ghc-hscolour-devel.x86_64: W: no-documentation
ghc-hscolour-prof.x86_64: W: no-documentation
ghc-hscolour-prof.x86_64: W: devel-file-in-non-devel-package /usr/lib64/ghc-6.10.1/hscolour-1.12/libHShscolour-1.12_p.a
ghc-hscolour-prof.x86_64: E: devel-dependency ghc-hscolour-devel
hscolour.x86_64: E: non-standard-executable-perm /usr/bin/HsColour 0775
hscolour.x86_64: W: executable-stack /usr/bin/HsColour
5 packages and 0 specfiles checked; 2 errors, 4 warnings.

# MUST: The package must be named according to the Package Naming Guidelines .
Check
# MUST: The spec file name must match the base package %{name}, in the format %{name}.spec unless your package has an exemption. [2] .
Check
# MUST: The package must meet the Packaging Guidelines .
FAIL: see rpmlint error about file permissions
# MUST: The package must be licensed with a Fedora approved license and meet the Licensing Guidelines .
Check
# MUST: The License field in the package spec file must match the actual license. [3]
Check
# MUST: If (and only if) the source package includes the text of the license(s) in its own file, then that file, containing the text of the license(s) for the package must be included in %doc.[4]
Check
# MUST: The spec file must be written in American English. [5]
To the supposed chagrin of the author, Check :)
# MUST: The spec file for the package MUST be legible. [6]
Check, but please use block instead of cursive next time.
# MUST: The sources used to build the package must match the upstream source, as provided in the spec URL. Reviewers should use md5sum for this task. If no upstream URL can be specified for this package, please see the Source URL Guidelines for how to deal with this.
Check - 4328a84b87b245693bcf10b49c608e43
# MUST: The package MUST successfully compile and build into binary rpms on at least one primary architecture. [7]
Check - x86_64
# MUST: If the package does not successfully compile, build or work on an architecture, then those architectures should be listed in the spec in ExcludeArch. Each architecture listed in ExcludeArch MUST have a bug filed in bugzilla, describing the reason that the package does not compile/build/work on that architecture. The bug number MUST be placed in a comment, next to the corresponding ExcludeArch line. [8]
Currently excludes ppc64 in conformance with ghc issues. Check.
# MUST: All build dependencies must be listed in BuildRequires, except for any that are listed in the exceptions section of the Packaging Guidelines ; inclusion of those as BuildRequires is optional. Apply common sense.
Check.
# MUST: The spec file MUST handle locales properly. This is done by using the %find_lang macro. Using %{_datadir}/locale/* is strictly forbidden.[9]
N/A
# MUST: Every binary RPM package (or subpackage) which stores shared library files (not just symlinks) in any of the dynamic linker's default paths, must call ldconfig in %post and %postun. [10]
N/A
# MUST: If the package is designed to be relocatable, the packager must state this fact in the request for review, along with the rationalization for relocation of that specific package. Without this, use of Prefix: /usr is considered a blocker. [11]
N/A
# MUST: A package must own all directories that it creates. If it does not create a directory that it uses, then it should require a package which does create that directory. [12]
Check
# MUST: A package must not contain any duplicate files in the %files listing. [13]
Check
# MUST: Permissions on files must be set properly. Executables should be set with executable permissions, for example. Every %files section must include a %defattr(...) line. [14]
Fail: See above rpmlint
# MUST: Each package must have a %clean section, which contains rm -rf %{buildroot} (or $RPM_BUILD_ROOT). [15]
Check
# MUST: Each package must consistently use macros. [16]
Check
# MUST: The package must contain code, or permissable content. [17]
Check
# MUST: Large documentation files must go in a -doc subpackage. (The definition of large is left up to the packager's best judgement, but is not restricted to size. Large can refer to either size or quantity). [18]
Check
# MUST: If a package includes something as %doc, it must not affect the runtime of the application. To summarize: If it is in %doc, the program must run properly if it is not present. [18]
Check
# MUST: Header files must be in a -devel package. [19]
Check
# MUST: Static libraries must be in a -static package. [20]
N/A
# MUST: Packages containing pkgconfig(.pc) files must 'Requires: pkgconfig' (for directory ownership and usability). [21]
N/A
# MUST: If a package contains library files with a suffix (e.g. libfoo.so.1.1), then library files that end in .so (without suffix) must go in a -devel package. [19]
N/A
# MUST: In the vast majority of cases, devel packages must require the base package using a fully versioned dependency: Requires: %{name} = %{version}-%{release} [22]
N/A
# MUST: Packages must NOT contain any .la libtool archives, these must be removed in the spec if they are built.[20]
Check
# MUST: Packages containing GUI applications must include a %{name}.desktop file, and that file must be properly installed with desktop-file-install in the %install section. If you feel that your packaged GUI application does not need a .desktop file, you must put a comment in the spec file with your explanation. [23]
N/A
# MUST: Packages must not own files or directories already owned by other packages. The rule of thumb here is that the first package to be installed should own the files or directories that other packages may rely upon. This means, for example, that no package in Fedora should ever share ownership with any of the files or directories owned by the filesystem or man package. If you feel that you have a good reason to own a file or directory that another package owns, then please present that at package review time. [24]
Check
# MUST: At the beginning of %install, each package MUST run rm -rf %{buildroot} (or $RPM_BUILD_ROOT). [25]
Check
# MUST: All filenames in rpm packages must be valid UTF-8. [26]
Check

*  SHOULD: If the source package does not include license text(s) as a separate file from upstream, the packager SHOULD query upstream to include it. [27]
N/A
* SHOULD: The description and summary sections in the package spec file should contain translations for supported Non-English languages, if available. [28]
N/A
* SHOULD: The reviewer should test that the package builds in mock. [29]
Check - x86_64
* SHOULD: The package should compile and build into binary rpms on all supported architectures. [30]
Not possible, lack of ppc machine.
* SHOULD: The reviewer should test that the package functions as described. A package should not segfault instead of running, for example.
Check
* SHOULD: If scriptlets are used, those scriptlets must be sane. This is vague, and left up to the reviewers judgement to determine sanity. [31]
Check
* SHOULD: Usually, subpackages other than devel should require the base package using a fully versioned dependency. [22]
Check
* SHOULD: The placement of pkgconfig(.pc) files depends on their usecase, and this is usually for development purposes, so should be placed in a -devel pkg. A reasonable exception is that the main pkg itself is a devel tool not installed in a user runtime, e.g. gcc or gdb. [21]
N/A
* SHOULD: If the package has file dependencies outside of /etc, /bin, /sbin, /usr/bin, or /usr/sbin consider requiring the package which provides the file instead of the file itself. [32] 
N/A
Comment 2 Jens Petersen 2009-03-10 07:15:01 EDT
[ok, take2: first attempt to reply earlier disappeared with firefox...]

(In reply to comment #1)
> http://www.cs.york.ac.uk/fp/darcs/hscolour/

Thanks - fixing.

> IMO the upstream maintains a nice website.

Agreed better to use an upstream website when available and up to date.

> ghc-hscolour-devel.x86_64: W: no-documentation
> ghc-hscolour-prof.x86_64: W: no-documentation
> ghc-hscolour-prof.x86_64: W: devel-file-in-non-devel-package
> ghc-hscolour-prof.x86_64: E: devel-dependency ghc-hscolour-devel

These can be waived I think.

> hscolour.x86_64: E: non-standard-executable-perm /usr/bin/HsColour 0775

Reproduced and still investigating.

> hscolour.x86_64: W: executable-stack /usr/bin/HsColour

Yes, I think this is common to ghc executables.
I checked and alex, cabal-install, cpphs, ghc, darcs, happy, etc
all have this too.

> # MUST: Permissions on files must be set properly. Executables should be set
> with executable permissions, for example. Every %files section must include a
> %defattr(...) line. [14]
> Fail: See above rpmlint

Fixing with %attr for now anyway.

SPEC: http://petersen.fedorapeople.org/hscolour/hscolour.spec
SRPM: http://petersen.fedorapeople.org/hscolour/hscolour-1.12-2.fc10.src.rpm
Comment 3 Yaakov Nemoy 2009-03-13 19:00:09 EDT
Ok, URL is good.
Waiving the warnings and error that can be waived for the obvious reasons. They were included only for completeness.

I'm gonna let the executable-stack warning pass for now. This might bear some looking into.

The other issues have been fixed, so this is APPROVED.
Comment 4 Jens Petersen 2009-03-17 04:34:16 EDT
Thanks for the review.


New Package CVS Request
=======================
Package Name: hscolour
Short Description: Haskell source highlighting
Owners: petersen
Branches: F-10
InitialCC: haskell-sig
Comment 5 Kevin Fenzi 2009-03-17 23:31:06 EDT
cvs done.
Comment 6 Jens Petersen 2009-03-18 01:42:50 EDT
imported and built
Comment 7 Jens Petersen 2010-09-30 02:11:49 EDT
Package Change Request
======================
Package Name: hscolour
New Branches: el6
Owners: petersen
InitialCC: haskell-sig
Comment 8 Kevin Fenzi 2010-10-03 16:24:12 EDT
Git done (by process-git-requests).
Comment 9 Jens Petersen 2012-06-02 03:28:28 EDT
Package Change Request
======================
Package Name: hscolour
New Branches: el5
Owners: petersen
InitialCC: haskell-sig
Comment 10 Jon Ciesla 2012-06-02 13:30:51 EDT
Git done (by process-git-requests).

Note You need to log in before you can comment on or make changes to this bug.